SystemOrganization addCategory: #'Compiler-Requests'!

Object subclass: #CompilerRequest
	instanceVariableNames: 'target requestor failBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compiler-Requests'!

!CompilerRequest methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 13:07'!
failBlock

	^ failBlock! !

!CompilerRequest methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 13:07'!
failBlock: anObject

	failBlock := anObject! !

!CompilerRequest methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 13:25'!
processRequest
	^self subclassResponsibility! !

!CompilerRequest methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 13:07'!
requestor

	^ requestor! !

!CompilerRequest methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 13:07'!
requestor: anObject

	requestor := anObject! !

!CompilerRequest methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 13:25'!
sendTo: anObject
	target :=anObject.
	^self processRequest.! !

!CompilerRequest methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 13:26'!
target

	^ target! !

!CompilerRequest methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 13:26'!
target: anObject

	target := anObject! !

CompilerRequest subclass: #MethodCompilerRequest
	instanceVariableNames: 'source sourceStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compiler-Requests'!

MethodCompilerRequest subclass: #EvaluateRequest
	instanceVariableNames: 'runtimeContext logged compileContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compiler-Requests'!

!EvaluateRequest class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/23/2011 17:23'!
evaluate: sourceString
	^(self new source: sourceString) processRequest.! !

!EvaluateRequest class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/23/2011 17:29'!
evaluateAndLog: sourceString
	^(self new source: sourceString;logged: true) processRequest.! !

!EvaluateRequest methodsFor: 'accessing' stamp: 'EstebanAllende 12/23/2011 17:25'!
compileContext: anObject

	compileContext := anObject! !

!EvaluateRequest methodsFor: 'accessing' stamp: 'EstebanAllende 12/23/2011 17:22'!
initialize
	logged := false.
	failBlock := [nil].! !

!EvaluateRequest methodsFor: 'accessing' stamp: 'EstebanAllende 12/23/2011 15:36'!
logged

	^ logged! !

!EvaluateRequest methodsFor: 'accessing' stamp: 'EstebanAllende 12/23/2011 15:36'!
logged: anObject

	logged := anObject! !

!EvaluateRequest methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/23/2011 17:25'!
processRequest
	|ctx  methodNode method value|
	ctx := compileContext ifNil: [self target class compilerContext].
	value := ctx compiler methodCompiler evaluateWithRequest: self usingCompilerContext: ctx.

	self logged ifTrue:
		[|toLog itsSelection itsSelectionString|
			toLog := ((requestor respondsTo: #selection)  
			and:[(itsSelection := requestor selection) notNil
			and:[(itsSelectionString := itsSelection asString) isEmptyOrNil not]])
				ifTrue:[itsSelectionString]
				ifFalse:[self sourceStream contents].
		SystemChangeNotifier uniqueInstance evaluated: toLog context: runtimeContext].
	^ value! !

!EvaluateRequest methodsFor: 'accessing' stamp: 'EstebanAllende 12/23/2011 16:13'!
runtimeContext

	^ runtimeContext! !

!EvaluateRequest methodsFor: 'accessing' stamp: 'EstebanAllende 12/23/2011 16:13'!
runtimeContext: anObject

	runtimeContext := anObject! !

MethodCompilerRequest subclass: #MethodCompileRequest
	instanceVariableNames: 'category trailer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compiler-Requests'!

!MethodCompileRequest methodsFor: 'accessing' stamp: 'EstebanAllende 12/23/2011 14:58'!
category

	^ category! !

!MethodCompileRequest methodsFor: 'accessing' stamp: 'EstebanAllende 12/23/2011 14:58'!
category: anObject

	category := anObject! !

!MethodCompileRequest methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/23/2011 15:02'!
processRequest
	|ctx|
	ctx := CompilerFrontend compilerContextForClass: self target.
	^ctx compiler methodCompiler compileWithRequest: self usingCompilerContext: ctx
! !

!MethodCompileRequest methodsFor: 'accessing' stamp: 'EstebanAllende 12/23/2011 14:58'!
trailer

	^ trailer! !

!MethodCompileRequest methodsFor: 'accessing' stamp: 'EstebanAllende 12/23/2011 14:58'!
trailer: anObject

	trailer := anObject! !

!MethodCompilerRequest methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 13:11'!
source

	^ source! !

!MethodCompilerRequest methodsFor: 'accessing' stamp: 'EstebanAllende 12/15/2011 16:50'!
source: anObject

	source := anObject.
	sourceStream := nil.! !

!MethodCompilerRequest methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 17:58'!
sourceStream

	sourceStream ifNil: [
		(source isKindOf: PositionableStream)
			ifTrue: [sourceStream := source]
			ifFalse: [sourceStream := source asString readStream].
	].
	^sourceStream! !

!MethodCompilerRequest methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 22:12'!
sourceStream: anObject

	sourceStream := anObject! !

MethodCompilerRequest subclass: #MethodParseRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Compiler-Requests'!

!MethodParseRequest methodsFor: 'accessing' stamp: 'EstebanAllende 12/23/2011 14:55'!
processRequest
	|ctx|
	ctx := CompilerFrontend compilerContextForClass: self target.
	^ctx compiler methodCompiler parseWithRequest: self usingCompilerContext: ctx.! !
